# Tkinter Sudoku Solver

## About

This application solves classic sudoku puzzles. It is written in
Python with an interface built using tkinter.

Some notable features about this application:

* Real-time visual representation of the solution algorithm
* Solve user-defined puzzles or use built-in sample puzzles
* Control over the speed of the solver
* Colorblind mode

![regular mode](docs/images/reg-mode.png "Regular mode")
![colorblind mode](docs/images/cb-mode.png "Colorblind mode")

## Compatibility

Full compatibility with Python 3.9 on Linux.

More details regarding other Python version and operating systems can
be found in the [documentation](docs/compatibility.md).

## Installation

Running `pip install tssolver` will use pip to install the package.
After installing, `tssolver` will run the application.

## Contributing

Please report any bugs to the
[GitLab issue tracker](https://gitlab.com/emerac/tkinter-sudoku-solver/-/issues).
See [CONTRIBUTING](CONTRIBUTING.md) for more details.

## License

This program is free software and is licensed under the GNU General
Public License. For the full license text, view the [LICENSE](LICENSE)
file.

Copyright © 2021 emerac
